
#pragma once

#include "Common.h"
#include "ObjectData.h"

class Plank : public ObjectData
{
public:

    Plank(bool render,       // TODO: add orientation
         bool physics, 
         const btVector3& pos, 
         float scale,       // TODO: make scale a width, height and depth
         const D3DCOLORVALUE& color, 
         short collisionGroup = COL_NOTHING,
         short collisionMask = COL_NOTHING,
         const btVector3& vel = btVector3(0,0,0));
    ~Plank();

    static void Init(IDirect3DDevice9* pDevice, btDiscreteDynamicsWorld* pWorld);
    static void OnLostDevice();
    static void OnResetDevice();
    static void Destroy();
    static RenderData* GetRenderData();

protected:
    Plank(){};   // Don't call this


private:

    // Render Data
    static Vertex PlankVertices[];
    static short PlankIndices[];
    static InitRenderData PlankRenderData;
    static RenderData* pRenderData;

    // Physics Data
    static btDiscreteDynamicsWorld* g_pBtDynamicsWorld;
};
